<?php

namespace App\Controller;

use App\Entity\User;
use App\Repository\ReleaseRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class UserReleasesController extends AbstractController
{
    #[Route('/@{username}/releases', name: 'app_user_releases')]
    public function index(
        User $user,
        ReleaseRepository $releaseRepository,
    ): Response
    {
        $releases = $releaseRepository->getUserListing($user);
        return $this->render(
            'user_releases/index.html.twig',
            [
                'username' => $user->getUsername(),
                'releases' => $releases,
            ]
        );
    }
}
